# Define the kmod package name here.
%define kmod_name rt3572sta

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion `uname -r`}

Name:    %{kmod_name}-kmod
Version: 2.5.0.0
Release: 1%{?dist}
Group:   System Environment/Kernel
License: GPLv2
Summary: %{kmod_name} kernel module(s)
URL:     http://www.ralinktech.com

BuildRequires: redhat-rpm-config
BuildRequires: perl
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-build-%(%{__id_u} -n)
ExclusiveArch: i686 x86_64

# Sources.
Source0:  2011_0427_RT3572_Linux_STA_v2.5.0.0.DPO.bz2
Source1:  rt3572sta.conf
Source5:  GPL-v2.0.txt
Source10: kmodtool-%{kmod_name}-fc16.sh

# Patches.
Patch0: supplicant-led.patch
Patch1: device-id.patch
Patch2: alloc-coherent.patch

# Magic hidden here.
%{expand:%(sh %{SOURCE10} rpmtemplate %{kmod_name} %{kversion} "")}

# Disable the building of the debug package(s).
%define debug_package %{nil}

%description
This package provides the %{kmod_name} kernel module(s) for the
RaLink RT3572 USB wireless series network adapters.
It is built to depend upon the specific ABI provided by a range of releases
of the same variant of the Linux kernel and not on any one specific build.

%prep
%setup -q -c -T -a 0
%patch0 -p1
%patch1 -p1
%patch2 -p1
%{__cp} -a 2011_0427_RT3572_Linux_STA_v2.5.0.0.DPO _kmod_build_
%{__cp} -a %{SOURCE5} _kmod_build_/
%{__cp} -a %{SOURCE1} _kmod_build_/
echo "override %{kmod_name} * weak-updates/%{kmod_name}" > _kmod_build_/kmod-%{kmod_name}.conf

%build
pushd _kmod_build_
%{__make} LINUX_SRC=%{_usrsrc}/kernels/%{kversion}
popd

%install
pushd _kmod_build_
%{__install} -d %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} os/linux/rt3572sta.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} -d %{buildroot}%{_sysconfdir}/Wireless/RT2870STA/
%{__install} RT2870STA.dat %{buildroot}%{_sysconfdir}/Wireless/RT2870STA/
%{__install} RT2870STACard.dat %{buildroot}%{_sysconfdir}/Wireless/RT2870STA/
%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} -d %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} GPL-v2.0.txt %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
# Install docs
%{__install} *.txt %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} README_STA %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} -d %{buildroot}/etc/modprobe.d/
%{__install} rt3572sta.conf %{buildroot}/etc/modprobe.d/
popd
# Set the module(s) to be executable, so that they will be stripped when packaged.
find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;
# Remove the unrequired files.
%{__rm} -f %{buildroot}/lib/modules/%{kversion}/modules.*

%clean
%{__rm} -rf %{buildroot}

%changelog
* Thu Feb 23 2012 David Dreggors <ddreggors@systeknow.com> - 2.5.0.0-1.fc16
- First build for Fedora 16
- Patched to include the AE1000 USB WiFi card
- Added firmware to rpm
- Added modprobe.d conf
